#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka import User, utils
from prewikka.templates.MessageListing import MessageListing

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0.1'
__CHEETAH_versionTuple__ = (2, 0, 1, 'final', 0)
__CHEETAH_genTime__ = 1244966471.0660851
__CHEETAH_genTimestamp__ = 'Sun Jun 14 10:01:11 2009'
__CHEETAH_src__ = 'prewikka/templates/AlertListing.tmpl'
__CHEETAH_srcLastModified__ = 'Wed Jun 10 12:58:10 2009'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class AlertListing(MessageListing):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        MessageListing.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def head_extra_content(self, **KWS):



        ## CHEETAH: generated from #block head_extra_content at line 4, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_82421711 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''
<script type="text/javascript">
<!--
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_82421711
        _orig_filter_40153063 = _filter
        filterName = 'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''
var global_id = 0;
var value_array = Array();
var operator_array = Array();

var title_array = Array();
title_array["="] = "''')
        if False:
            _("Equal")
        _v = VFFSL(SL,"_",False)("Equal") # '$_("Equal")' on line 17, col 21
        if _v is not None: write(_filter(_v, rawExpr='$_("Equal")')) # from line 17, col 21.
        write('''";
title_array["!="] = "''')
        if False:
            _("Not equal")
        _v = VFFSL(SL,"_",False)("Not equal") # '$_("Not equal")' on line 18, col 22
        if _v is not None: write(_filter(_v, rawExpr='$_("Not equal")')) # from line 18, col 22.
        write('''";
title_array["<"] = "''')
        if False:
            _("Lesser than")
        _v = VFFSL(SL,"_",False)("Lesser than") # '$_("Lesser than")' on line 19, col 21
        if _v is not None: write(_filter(_v, rawExpr='$_("Lesser than")')) # from line 19, col 21.
        write('''";
title_array[">"] = "''')
        if False:
            _("Greater than")
        _v = VFFSL(SL,"_",False)("Greater than") # '$_("Greater than")' on line 20, col 21
        if _v is not None: write(_filter(_v, rawExpr='$_("Greater than")')) # from line 20, col 21.
        write('''";
title_array["<="] = "''')
        if False:
            _("Lesser or equal")
        _v = VFFSL(SL,"_",False)("Lesser or equal") # '$_("Lesser or equal")' on line 21, col 22
        if _v is not None: write(_filter(_v, rawExpr='$_("Lesser or equal")')) # from line 21, col 22.
        write('''";
title_array[">="] = "''')
        if False:
            _("Greater or equal")
        _v = VFFSL(SL,"_",False)("Greater or equal") # '$_("Greater or equal")' on line 22, col 22
        if _v is not None: write(_filter(_v, rawExpr='$_("Greater or equal")')) # from line 22, col 22.
        write('''";
title_array["<>"] = "''')
        if False:
            _("Substring")
        _v = VFFSL(SL,"_",False)("Substring") # '$_("Substring")' on line 23, col 22
        if _v is not None: write(_filter(_v, rawExpr='$_("Substring")')) # from line 23, col 22.
        write('''";
title_array["<>*"] = "''')
        if False:
            _("Substring (case-insensitive)")
        _v = VFFSL(SL,"_",False)("Substring (case-insensitive)") # '$_("Substring (case-insensitive)")' on line 24, col 23
        if _v is not None: write(_filter(_v, rawExpr='$_("Substring (case-insensitive)")')) # from line 24, col 23.
        write('''";
title_array["~"] = "''')
        if False:
            _("Regular expression")
        _v = VFFSL(SL,"_",False)("Regular expression") # '$_("Regular expression")' on line 25, col 21
        if _v is not None: write(_filter(_v, rawExpr='$_("Regular expression")')) # from line 25, col 21.
        write('''";
title_array["~*"] = "''')
        if False:
            _("Regular expression (case-insensitive)")
        _v = VFFSL(SL,"_",False)("Regular expression (case-insensitive)") # '$_("Regular expression (case-insensitive)")' on line 26, col 22
        if _v is not None: write(_filter(_v, rawExpr='$_("Regular expression (case-insensitive)")')) # from line 26, col 22.
        write('''";


 var saved_state = [ "classification", "source", "target", "analyzer" ];

 var saved_forms = Array();
 saved_forms["classification"] = [ "default", "saved", "current" ];
 saved_forms["source"] = [ "default", "saved", "current" ];
 saved_forms["target"] = [ "default", "saved", "current" ];
 saved_forms["analyzer"] = [ "default", "saved", "current" ];

function cloneForm(form) {
        var clone = $(form).clone();
        var selvals = [];

        $(form).filter("select").each(function() {
                selvals.push($(this).val());
        });

        $(clone).filter("select").each(function() {
                $(this).val(selvals.shift());
        });

        return clone;
}


function input_equal(a, b) {
        if ( a.type == "button" && b.type == "button" )
                return true;

        if ( a.name != b.name )
                return false;

        if ( a.checked != b.checked )
                return false;

        if ( a.selected != b.selected )
                return false;

        if ( a.value != b.value )
                return false;

        return true;
}

function Equals(a, b) {
  if( ! a || ! b )
        return false;

  if ( a.length != b.length )
        return false;

  for ( var k = 0; k < a.length; k++ ) {
        r = input_equal(a[k], b[k]);
        if ( r == false )
                return false;
  }

  return true;
}


function get_next_state(id, cstate) {
        var nextstate = null;
        var selector = "#" + id + " :input";

        if ( cstate == "current" ) {
                if ( saved_forms[id]["saved"] && ! Equals($(selector), saved_forms[id]["saved"]) )
                        nextstate = "saved";

                else if ( saved_forms[id]["default"] && ! Equals($(selector), saved_forms[id]["default"]) )
                        nextstate = "default";
        }

        else if ( cstate == "saved" ) {
                if ( saved_forms[id]["default"] && ! Equals($(selector), saved_forms[id]["default"]) )
                        nextstate = "default";

                else if ( saved_forms[id]["current"] && ! Equals($(selector), saved_forms[id]["current"]) )
                        nextstate = "current";
        }

        else if ( cstate == "default" ) {
                if ( saved_forms[id]["current"] && ! Equals($(selector), saved_forms[id]["current"]) )
                        nextstate = "current";

                else if ( saved_forms[id]["saved"] && ! Equals($(selector), saved_forms[id]["saved"]) )
                        nextstate = "saved";

                else nextstate = "default";
        }

        return nextstate;
}


function createSelectFromArray(varray, sclass, name_attr, selected, defsel) {
        var elem;
        var select = document.createElement("select");

        for (elem in varray) {
                option = document.createElement("option")
                option.setAttribute("value", varray[elem]);

                if ( title_array[varray[elem]] )
                        option.setAttribute("title", title_array[varray[elem]]);

                if ( varray[elem] == selected )
                        option.setAttribute("selected", "selected");

                option.appendChild(document.createTextNode(varray[elem]))
                select.appendChild(option)
        }

        select.setAttribute("name", name_attr);
        select.setAttribute("class", sclass);

        return select;
}



''')
        # # Generate special classification function
        for state, type, severity, completion in ("current", VFFSL(SL,"alert.type",True), VFFSL(SL,"alert.assessment.impact.severity",True), VFFSL(SL,"alert.assessment.impact.completion",True)), ("saved", VFFSL(SL,"alert.type_saved",True), VFFSL(SL,"alert.assessment.impact.severity_saved",True), VFFSL(SL,"alert.assessment.impact.completion_saved",True)), ("default", VFFSL(SL,"alert.type_default",True), VFFSL(SL,"alert.assessment.impact.severity_default",True), VFFSL(SL,"alert.assessment.impact.completion_default",True)),: # generated from line 152, col 1
            write('''
function classification_special_''')
            _v = VFFSL(SL,"state",True) # '${state}' on line 154, col 33
            if _v is not None: write(_filter(_v, rawExpr='${state}')) # from line 154, col 33.
            write('''() {
''')
            for path in "alert.create_time", "alert.correlation_alert.name", "alert.overflow_alert.program", "alert.tool_alert.name": # generated from line 155, col 2
                if path in VFFSL(SL,"type",True): # generated from line 156, col 3
                    write('''   $("input[value=\'''')
                    _v = VFFSL(SL,"path",True) # '${path}' on line 157, col 21
                    if _v is not None: write(_filter(_v, rawExpr='${path}')) # from line 157, col 21.
                    write('''\']").attr("checked", "checked");
''')
                else: # generated from line 158, col 3
                    write('''   $("input[value=\'''')
                    _v = VFFSL(SL,"path",True) # '${path}' on line 159, col 21
                    if _v is not None: write(_filter(_v, rawExpr='${path}')) # from line 159, col 21.
                    write('''\']").removeAttr("checked");
''')
            write('''
 var input = $("#classification input[name=\'alert.assessment.impact.severity\']");

 ''')
            if False:
                N_("info")
            if False:
                N_("low")
            if False:
                N_("medium")
            if False:
                N_("high")
            if False:
                N_("none")
            for item in VFFSL(SL,"N_",False)("info"), VFFSL(SL,"N_",False)("low"), VFFSL(SL,"N_",False)("medium"), VFFSL(SL,"N_",False)("high"), VFFSL(SL,"N_",False)("none"): # generated from line 165, col 2
                if VFFSL(SL,"item",True) in VFFSL(SL,"severity",True): # generated from line 166, col 3
                    write('''  $(input).filter("[value=\'''')
                    _v = VFFSL(SL,"item",True) # '$item' on line 167, col 29
                    if _v is not None: write(_filter(_v, rawExpr='$item')) # from line 167, col 29.
                    write('''\']").attr("checked", "checked");
''')
                else: # generated from line 168, col 3
                    write('''  $(input).filter("[value=\'''')
                    _v = VFFSL(SL,"item",True) # '$item' on line 169, col 29
                    if _v is not None: write(_filter(_v, rawExpr='$item')) # from line 169, col 29.
                    write('''\']").removeAttr("checked");
''')
            write('''
 input = $("#classification input[name=\'alert.assessment.impact.completion\']");
 ''')
            if False:
                N_("succeeded")
            if False:
                N_("failed")
            if False:
                N_("none")
            for item in VFFSL(SL,"N_",False)("succeeded"), VFFSL(SL,"N_",False)("failed"), VFFSL(SL,"N_",False)("none"): # generated from line 174, col 2
                if item in VFFSL(SL,"completion",True): # generated from line 175, col 3
                    write('''  $(input).filter("[value=\'''')
                    _v = VFFSL(SL,"item",True) # '$item' on line 176, col 29
                    if _v is not None: write(_filter(_v, rawExpr='$item')) # from line 176, col 29.
                    write('''\']").attr("checked", "checked");
''')
                else: # generated from line 177, col 3
                    write('''  $(input).filter("[value=\'''')
                    _v = VFFSL(SL,"item",True) # '$item' on line 178, col 29
                    if _v is not None: write(_filter(_v, rawExpr='$item')) # from line 178, col 29.
                    write('''\']").removeAttr("checked");
''')
            write('''}

''')
        write('''


''')
        for type, table_current, table_saved, table_aggreg_current, table_aggreg_saved, table_aggreg_default in ("classification", VFFSL(SL,"classification",True), VFFSL(SL,"classification_saved",True), VFFSL(SL,"aggregated_classification",True), VFFSL(SL,"aggregated_classification_saved",True), VFFSL(SL,"aggregated_classification_default",True)), ("source", VFFSL(SL,"source",True), VFFSL(SL,"source_saved",True), VFFSL(SL,"aggregated_source",True), VFFSL(SL,"aggregated_source_saved",True), VFFSL(SL,"aggregated_source_default",True)), ("target", VFFSL(SL,"target",True), VFFSL(SL,"target_saved",True), VFFSL(SL,"aggregated_target",True), VFFSL(SL,"aggregated_target_saved",True), VFFSL(SL,"aggregated_target_default",True)), ("analyzer", VFFSL(SL,"analyzer",True), VFFSL(SL,"analyzer_saved",True), VFFSL(SL,"aggregated_analyzer",True), VFFSL(SL,"aggregated_analyzer_saved",True), VFFSL(SL,"aggregated_analyzer_default",True)): # generated from line 187, col 1
            write('''
function ''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 189, col 10
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 189, col 10.
            write('''_filters_set_from_string(state) {
        if ( state == "saved" )
                ''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 191, col 17
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 191, col 17.
            write('''_set_saved();

        else if ( state == "default" )
                ''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 194, col 17
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 194, col 17.
            write('''_set_default()

        else if ( state == "current" )
                ''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 197, col 17
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 197, col 17.
            write('''_set_current();
}

function ''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 200, col 10
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 200, col 10.
            write('''_zero() {
 var filter_table = $("#''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 201, col 26
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 201, col 26.
            write(''' table.filter_table > tbody");
 filter_table.find("tr:not(\':first\')").remove()
 filter_table.find("input[type=text]").val("")
 $("#''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 204, col 7
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 204, col 7.
            write(''' table.aggregation_table tr:not(\':first\')").remove()
}

function ''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 207, col 10
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 207, col 10.
            write('''_set_default() {
 ''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 208, col 2
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 208, col 2.
            write('''_zero();
 var table = $("#''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 209, col 19
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 209, col 19.
            write(''' table.aggregation_table > tbody");

''')
            if VFFSL(SL,"type",True) == "classification": # generated from line 211, col 3
                write('''   ''')
                _v = VFFSL(SL,"type",True) # '${type}' on line 212, col 4
                if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 212, col 4.
                write('''_special_default();
''')
            write('''

''')
            # # Aggregation stuff
            cnt = 0
            for path in VFFSL(SL,"table_aggreg_default",True): # generated from line 218, col 3
                write('''
''')
                if VFFSL(SL,"cnt",True) > 0: # generated from line 220, col 4
                    write('''    table.find("tr:last a.append_entry").trigger(\'click\');
''')
                cnt += 1
                write('''
   table.find("tr:last .popup_input_field option[value=\'''')
                _v = VFFSL(SL,"path",True) # '$path' on line 225, col 57
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 225, col 57.
                write('''\']").attr("selected", "selected");
''')
            write('''}

''')
            for state, table, table_aggreg in ("current", VFFSL(SL,"table_current",True), VFFSL(SL,"table_aggreg_current",True)), ("saved", VFFSL(SL,"table_saved",True), VFFSL(SL,"table_aggreg_saved",True)): # generated from line 229, col 1
                write('''function ''')
                _v = VFFSL(SL,"type",True) # '${type}' on line 230, col 10
                if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 230, col 10.
                write('''_set_''')
                _v = VFFSL(SL,"state",True) # '${state}' on line 230, col 22
                if _v is not None: write(_filter(_v, rawExpr='${state}')) # from line 230, col 22.
                write('''() {
  ''')
                _v = VFFSL(SL,"type",True) # '${type}' on line 231, col 3
                if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 231, col 3.
                write('''_zero();
  var table = $("#''')
                _v = VFFSL(SL,"type",True) # '${type}' on line 232, col 20
                if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 232, col 20.
                write(''' table.filter_table > tbody");
  var agtable = $("#''')
                _v = VFFSL(SL,"type",True) # '${type}' on line 233, col 22
                if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 233, col 22.
                write(''' table.aggregation_table > tbody");

''')
                if VFFSL(SL,"type",True) == "classification": # generated from line 235, col 3
                    write('''   ''')
                    _v = VFFSL(SL,"type",True) # '${type}' on line 236, col 4
                    if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 236, col 4.
                    write('''_special_''')
                    _v = VFFSL(SL,"state",True) # '${state}' on line 236, col 20
                    if _v is not None: write(_filter(_v, rawExpr='${state}')) # from line 236, col 20.
                    write('''();
''')
                write('''
''')
                cnt = 0
                for path, operator, value in VFFSL(SL,"table",True): # generated from line 240, col 3
                    write('''
''')
                    if VFFSL(SL,"cnt",True) > 0: # generated from line 242, col 4
                        write('''    table.find("tr:last a.append_entry").trigger(\'click\');
''')
                    cnt += 1
                    write('''
''')
                    if not VFFSL(SL,"path",True): # generated from line 247, col 3
                        continue
                    write('''
''')
                    if VFFSL(SL,"path",True) != "__all__": # generated from line 251, col 3
                        write('''   table.find("tr:last .popup_select_field option[value=\'''')
                        _v = VFFSL(SL,"path",True) # '$path' on line 252, col 58
                        if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 252, col 58.
                        write('''\']").attr("selected", "selected");
   table.find("tr:last .popup_operator_select option[value=\'''')
                        _v = VFFSL(SL,"operator",True) # '$operator' on line 253, col 61
                        if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 253, col 61.
                        write('''\']").attr("selected", "selected");
   table.find("tr:last .expert_mode").trigger("click");
''')
                    else: # generated from line 255, col 3
                        write('''   table.find("tr:last .popup_select_field").hide();
   table.find("tr:last .popup_select_field").attr("disabled", "disabled");
''')
                    write('''
  table.find("tr:last .popup_input_field").attr("value", "''')
                    _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"value",True)) # '$utils.escape_attribute($value)' on line 260, col 59
                    if _v is not None: write(_filter(_v, rawExpr='$utils.escape_attribute($value)')) # from line 260, col 59.
                    write('''");
  table.find("tr:last .popup_input_field option[value=\'''')
                    _v = VFFSL(SL,"value",True) # '$value' on line 261, col 56
                    if _v is not None: write(_filter(_v, rawExpr='$value')) # from line 261, col 56.
                    write('''\']").attr("selected", "selected");
''')
                write('''
  table.find("tr .popup_select_field").trigger("change");

''')
                # # Aggregation stuff
                cnt = 0
                for path in VFFSL(SL,"table_aggreg",True): # generated from line 268, col 3
                    write('''
''')
                    if VFFSL(SL,"cnt",True) > 0: # generated from line 270, col 4
                        write('''    agtable.find("tr:last a.append_entry").trigger(\'click\');
''')
                    cnt += 1
                    write('''
   agtable.find("tr:last .popup_input_field option[value=\'''')
                    _v = VFFSL(SL,"path",True) # '$path' on line 275, col 59
                    if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 275, col 59.
                    write('''\']").attr("selected", "selected");
''')
                write(''' }
''')
        write('''


$(document).ready(function() {
 $(".expert_mode").live("click", function() {
        var td_container_path = $(this).parent().parent().children(".td_container_path");

        if ( ! $(td_container_path).children().is(":visible") ) {
                $(this).text("simple");
                $(this).parent().parent().children(".td_container_operator").children().show()
                $(td_container_path).children("select").show()
                $(td_container_path).children("input").attr("disabled", "disabled")
                $(td_container_path).children("select").removeAttr("disabled")
        } else {
                $(this).text("advanced");
                $(td_container_path).children().hide()
                $(this).parent().parent().children(".td_container_operator").children().hide()
                $(td_container_path).children("input").removeAttr("disabled")
                $(td_container_path).children("select").attr("disabled", "disabled")
        }
});

 $(".remove_entry").live("click", function() {
        $(this).parent().parent().remove();
 });

 $(".append_entry").live("click", function() {
   var tr = $(this).parent().parent().clone();
   var select = $(tr).children("td.td_container_path").children();
   var div_id = $(this).parent().parent().parent().parent().parent().parent().parent().parent().parent().attr("id");

   if ( $(this).parent().parent().parent().parent().is("table.aggregation_table") )
        $(select).attr("name", "aggregated_" + div_id);

   else {
        global_id += 1;

        var input = $(tr).children("td.td_container_value").children();
        $(tr).children("td.td_container_operator").children().attr("name", div_id + "_operator_" + global_id);
        $(input).attr("name", div_id + "_value_" + global_id);
        $(input).attr("value", "");
        $(input).find("option[value=\'none\']").attr("selected", "selected");
        $(select).attr("name", div_id + "_object_" + global_id);
   }

   $(this).parents(".inline_filter").after(tr);
   $(select).trigger("change");
   $(tr).children("td.td_container_remove").html("<a class=\\"remove_entry\\">-</a>");
 });


 $(".popup_select_field").live("change", function() {
          var td = $(this).parent();
          var str = $(this, "> option:selected").attr("value");
          var input = $(td).siblings(".td_container_value").children();

          if ( operator_array[str] ) {
                var old_select = $(td).siblings(".td_container_operator").children();
                // do not use visible here, this is called before the parent element is visible
                var display = $(old_select).css("display") != "none";
                var old_value = $(old_select).children(":selected").attr("value");

                select = createSelectFromArray(operator_array[str], "popup_operator_select", $(old_select).attr("name"), old_value);
                if ( ! display )
                        $(select).hide();

                $(old_select).replaceWith(select);
          }

          if ( value_array[str] ) {
                  select = createSelectFromArray(value_array[str], "popup_input_field", $(input).attr("name"), $(input).attr("value"));
                  $(input).replaceWith(select);
          }

          else {
                var n = document.createElement("input");
                n.setAttribute("type", "text");
                n.setAttribute("name", $(input).attr("name"));
                n.setAttribute("value", $(input).attr("value"));
                n.setAttribute("class", "popup_input_field");
                $(input).replaceWith(n);
          }
 });



''')
        for type in "classification", "source", "target", "analyzer": # generated from line 366, col 2
            write('''
 ''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 368, col 2
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 368, col 2.
            write('''_set_saved();
 saved_forms["''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 369, col 15
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 369, col 15.
            write('''"]["saved"] = cloneForm($("#''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 369, col 51
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 369, col 51.
            write(''' :input"));

 ''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 371, col 2
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 371, col 2.
            write('''_set_default();
 saved_forms["''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 372, col 15
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 372, col 15.
            write('''"]["default"] = cloneForm($("#''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 372, col 53
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 372, col 53.
            write(''' :input"));

 ''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 374, col 2
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 374, col 2.
            write('''_set_current();
 var form = $("#''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 375, col 18
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 375, col 18.
            write(''' :input");
 saved_forms["''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 376, col 15
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 376, col 15.
            write('''"]["current"] = cloneForm(form);

 if ( Equals(saved_forms["''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 378, col 27
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 378, col 27.
            write('''"]["default"], saved_forms["''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 378, col 62
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 378, col 62.
            write('''"]["saved"]) )
        saved_forms["''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 379, col 22
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 379, col 22.
            write('''"]["saved"] = null;

 if ( Equals(saved_forms["''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 381, col 27
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 381, col 27.
            write('''"]["current"], saved_forms["''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 381, col 62
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 381, col 62.
            write('''"]["default"]) )
        saved_forms["''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 382, col 22
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 382, col 22.
            write('''"]["current"] = null;

''')
            #  Set the current state
            write(''' if ( Equals(form, saved_forms["''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 385, col 33
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 385, col 33.
            write('''"]["default"]) )
        saved_state["''')
            _v = VFFSL(SL,"type",True) # '$type' on line 386, col 22
            if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 386, col 22.
            write('''"] = "default";

 else if ( Equals(form, saved_forms["''')
            _v = VFFSL(SL,"type",True) # '$type' on line 388, col 38
            if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 388, col 38.
            write('''"]["saved"]) )
        saved_state["''')
            _v = VFFSL(SL,"type",True) # '$type' on line 389, col 22
            if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 389, col 22.
            write('''"] = "saved";

 else if ( Equals(form, saved_forms["''')
            _v = VFFSL(SL,"type",True) # '$type' on line 391, col 38
            if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 391, col 38.
            write('''"]["current"]) )
        saved_state["''')
            _v = VFFSL(SL,"type",True) # '$type' on line 392, col 22
            if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 392, col 22.
            write('''"] = "current";

 $("#''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 394, col 7
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 394, col 7.
            write(''' input.reset_filter").val("Reset to " + get_next_state("''')
            _v = VFFSL(SL,"type",True) # '$type' on line 394, col 70
            if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 394, col 70.
            write('''", saved_state["''')
            _v = VFFSL(SL,"type",True) # '$type' on line 394, col 91
            if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 394, col 91.
            write('''"]));

''')
        write('''

$("input.reset_filter").click(function() {
        var div_id = $(this).parent().parent().parent().parent().parent().parent().parent().parent().parent().attr("id");
        saved_state[div_id] = get_next_state(div_id, saved_state[div_id]);

''')
        for t in "classification", "source", "target", "analyzer": # generated from line 403, col 9
            write('''                if ( div_id == "''')
            _v = VFFSL(SL,"t",True) # '$t' on line 404, col 33
            if _v is not None: write(_filter(_v, rawExpr='$t')) # from line 404, col 33.
            write('''" )
                        ''')
            _v = VFFSL(SL,"t",True) # '${t}' on line 405, col 25
            if _v is not None: write(_filter(_v, rawExpr='${t}')) # from line 405, col 25.
            write('''_filters_set_from_string(saved_state[div_id]);
''')
        write('''
        $(this).val("Reset to " + get_next_state(div_id, saved_state[div_id]));
 });
});

//--></script>

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_40153063
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def define_inline_filter(self, obname, preselect, **KWS):



        ## CHEETAH: generated from #def define_inline_filter($obname, $preselect) at line 417, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''      <table class="inline_filter_content filter_table">
       <tr class="inline_filter">
        <th>''')
        if False:
            _('Filter on')
        _v = VFFSL(SL,"_",False)('Filter on') # "$_('Filter on')" on line 420, col 13
        if _v is not None: write(_filter(_v, rawExpr="$_('Filter on')")) # from line 420, col 13.
        write(''' [<a class="expert_mode">advanced</a>]:</th>
        <td class="td_container_path">
         <input type="hidden" name="''')
        _v = VFFSL(SL,"obname",True) # '${obname}' on line 422, col 37
        if _v is not None: write(_filter(_v, rawExpr='${obname}')) # from line 422, col 37.
        write('''_object_0" value="__all__" />
         <select style="display:none;" disabled="disabled" class="popup_select_field" name="''')
        _v = VFFSL(SL,"obname",True) # '${obname}' on line 423, col 93
        if _v is not None: write(_filter(_v, rawExpr='${obname}')) # from line 423, col 93.
        write('''_object_0">
''')
        for name, path, oplist, value in VFFSL(SL,"all_filters",True)[VFFSL(SL,"obname",True)]: # generated from line 424, col 11
            write('''
''')
            if VFFSL(SL,"value",True) or VFFSL(SL,"oplist",True): # generated from line 426, col 12
                write('''           <script type="text/javascript">
''')
                if VFFSL(SL,"value",True): # generated from line 428, col 13
                    write('''            value_array["''')
                    _v = VFFSL(SL,"path",True) # '$path' on line 429, col 26
                    if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 429, col 26.
                    write('''"] = ''')
                    _v = VFFSL(SL,"value",True) # '$value' on line 429, col 36
                    if _v is not None: write(_filter(_v, rawExpr='$value')) # from line 429, col 36.
                    write(''';
''')
                if VFFSL(SL,"oplist",True): # generated from line 431, col 13
                    write('''             operator_array["''')
                    _v = VFFSL(SL,"path",True) # '$path' on line 432, col 30
                    if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 432, col 30.
                    write('''"] = ''')
                    _v = VFFSL(SL,"oplist",True) # '$oplist' on line 432, col 40
                    if _v is not None: write(_filter(_v, rawExpr='$oplist')) # from line 432, col 40.
                    write(''';
''')
                write('''           </script>
''')
            write('''
''')
            if VFFSL(SL,"path",True) == None: # generated from line 437, col 12
                write('''            <option disabled="disabled" value="">''')
                _v = VFFSL(SL,"name",True) # '$name' on line 438, col 50
                if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 438, col 50.
                write('''</option>

''')
            elif VFFSL(SL,"path",True) == VFFSL(SL,"preselect",True): # generated from line 440, col 12
                write('''            <option value="''')
                _v = VFFSL(SL,"path",True) # '$path' on line 441, col 28
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 441, col 28.
                write('''" selected="selected">''')
                _v = VFFSL(SL,"name",True) # '$name' on line 441, col 55
                if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 441, col 55.
                write('''</option>

''')
            else: # generated from line 443, col 12
                write('''            <option value="''')
                _v = VFFSL(SL,"path",True) # '$path' on line 444, col 28
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 444, col 28.
                write('''">''')
                _v = VFFSL(SL,"name",True) # '$name' on line 444, col 35
                if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 444, col 35.
                write('''</option>
''')
        write('''         </select>
        </td>

        <td class="td_container_operator">
         <select style="display:none;" class="popup_operator_select" name="''')
        _v = VFFSL(SL,"obname",True) # '${obname}' on line 451, col 76
        if _v is not None: write(_filter(_v, rawExpr='${obname}')) # from line 451, col 76.
        write('''_operator_0" />
        </td>

        <td class="td_container_value">
         <input class="popup_input_field" type="text" name="''')
        _v = VFFSL(SL,"obname",True) # '${obname}' on line 455, col 61
        if _v is not None: write(_filter(_v, rawExpr='${obname}')) # from line 455, col 61.
        write('''_value_0" />
        </td>

        <td class="td_container_remove">&nbsp;</td>
        <td class="td_container_add"><a class="append_entry">+</a></td>
       </tr>
      </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def define_inline_aggreg(self, obname, **KWS):



        ## CHEETAH: generated from #def define_inline_aggreg($obname) at line 465, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''      <table class="inline_filter_content aggregation_table">
       <tr class="inline_filter">
        <th>''')
        if False:
            _('Group entry by:')
        _v = VFFSL(SL,"_",False)('Group entry by:') # "$_('Group entry by:')" on line 468, col 13
        if _v is not None: write(_filter(_v, rawExpr="$_('Group entry by:')")) # from line 468, col 13.
        write('''</th>
        <td class="td_container_path">
         <select class="popup_input_field" name="aggregated_''')
        _v = VFFSL(SL,"obname",True) # '${obname}' on line 470, col 61
        if _v is not None: write(_filter(_v, rawExpr='${obname}')) # from line 470, col 61.
        write('''">
''')
        for name, path, unuseda, unusedb in VFFSL(SL,"all_aggregs",True)[VFFSL(SL,"obname",True)]: # generated from line 471, col 11
            if VFFSL(SL,"path",True) == None: # generated from line 472, col 12
                write('''            <option disabled="disabled" value="">''')
                _v = VFFSL(SL,"name",True) # '$name' on line 473, col 50
                if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 473, col 50.
                write('''</option>
''')
            else: # generated from line 474, col 12
                write('''            <option value="''')
                _v = VFFSL(SL,"path",True) # '$path' on line 475, col 28
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 475, col 28.
                write('''">''')
                _v = VFFSL(SL,"name",True) # '$name' on line 475, col 35
                if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 475, col 35.
                write('''</option>
''')
        write('''         </select>
        </td>
        <td class="td_container_remove">&nbsp;</td>
        <td class="td_container_add"><a class="append_entry">+</a></td>
       </tr>
      </table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def filter_enabled_marker(self, type, **KWS):



        ## CHEETAH: generated from #def filter_enabled_marker($type) at line 486, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''  <span class="filter_enabled_marker filter_popup_link">
''')
        if VFFSL(SL,"type",True) == 2: # generated from line 488, col 4
            write('''    [<a class="filter_enabled_marker">''')
            if False:
                _("filtered")
            _v = VFFSL(SL,"_",False)("filtered") # '$_("filtered")' on line 489, col 39
            if _v is not None: write(_filter(_v, rawExpr='$_("filtered")')) # from line 489, col 39.
            write('''</a>]
''')
        else: # generated from line 490, col 4
            write('''    [<a style="color: gray;">''')
            if False:
                _("filtered")
            _v = VFFSL(SL,"_",False)("filtered") # '$_("filtered")' on line 491, col 30
            if _v is not None: write(_filter(_v, rawExpr='$_("filtered")')) # from line 491, col 30.
            write('''</a>]
''')
        write('''  </span>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def filter_reset(self, **KWS):



        ## CHEETAH: generated from #def filter_reset() at line 496, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<tr><td>
    <table class="inline_filter_content">
     <tr class="inline_filter">
      <td colspan="3">&nbsp;</td>
      <td>
       <input type="submit" value="Apply" />
       <input type="button" class="reset_filter" value="Reset" />
      </td>
     </tr>
    </table>
</td></tr>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def message_fields_header(self, **KWS):



        ## CHEETAH: generated from #block message_fields_header at line 510, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<thead>
 <tr style="height: 20px;">
  <th class="filter_popup">
   <a class="filter_popup_link">''')
        if False:
            _("Classification")
        _v = VFFSL(SL,"_",False)("Classification") # '$_("Classification")' on line 514, col 33
        if _v is not None: write(_filter(_v, rawExpr='$_("Classification")')) # from line 514, col 33.
        write('''</a>
''')
        if VFFSL(SL,"classification_filtered",True): # generated from line 515, col 5
            write('''     ''')
            _v = VFFSL(SL,"filter_enabled_marker",False)(VFFSL(SL,"classification_filtered",True)) # '$filter_enabled_marker($classification_filtered)' on line 516, col 6
            if _v is not None: write(_filter(_v, rawExpr='$filter_enabled_marker($classification_filtered)')) # from line 516, col 6.
            write('''
''')
        write('''   <div id="classification">
    <table>
     <tr><td>''')
        _v = VFFSL(SL,"define_inline_filter",False)("classification", "alert.classification.text") # '$define_inline_filter("classification", "alert.classification.text")' on line 520, col 14
        if _v is not None: write(_filter(_v, rawExpr='$define_inline_filter("classification", "alert.classification.text")')) # from line 520, col 14.
        write('''</td></tr>
     <tr><td>''')
        _v = VFFSL(SL,"define_inline_aggreg",False)("classification") # '$define_inline_aggreg("classification")' on line 521, col 14
        if _v is not None: write(_filter(_v, rawExpr='$define_inline_aggreg("classification")')) # from line 521, col 14.
        write('''</td></tr>
     <tr><td><table class="inline_filter_content">
       <tr>
        <th>''')
        if False:
            _("Type:")
        _v = VFFSL(SL,"_",False)("Type:") # '$_("Type:")' on line 524, col 13
        if _v is not None: write(_filter(_v, rawExpr='$_("Type:")')) # from line 524, col 13.
        write('''</th>
        <td>&nbsp;</td>
''')
        if VFFSL(SL,"correlation_alert_view",True): # generated from line 526, col 9
            disabled = "disabled=\"disabled\""
        else: # generated from line 528, col 9
            disabled = ""
        write('''
        ''')
        if False:
            N_("Alert")
        if False:
            N_("CorrelationAlert")
        if False:
            N_("OverflowAlert")
        if False:
            N_("ToolAlert")
        for name, path in ((VFFSL(SL,"N_",False)("Alert"), "alert.create_time"), (VFFSL(SL,"N_",False)("CorrelationAlert"), "alert.correlation_alert.name"),
                          (VFFSL(SL,"N_",False)("OverflowAlert"), "alert.overflow_alert.program"), (VFFSL(SL,"N_",False)("ToolAlert"), "alert.tool_alert.name")): # generated from line 532, col 9
            if path in VFFSL(SL,"alert.type",True): # generated from line 534, col 10
                checked = "checked='checked'"
            else: # generated from line 536, col 10
                checked = ""
            write('''
        <td>''')
            if False:
                _(VFFSL(SL,"name",True))
            _v = VFFSL(SL,"_",False)(VFFSL(SL,"name",True)) # '$_($name)' on line 540, col 13
            if _v is not None: write(_filter(_v, rawExpr='$_($name)')) # from line 540, col 13.
            write('''<input class="checkbox" ''')
            _v = VFFSL(SL,"disabled",True) # '$disabled' on line 540, col 46
            if _v is not None: write(_filter(_v, rawExpr='$disabled')) # from line 540, col 46.
            write(''' type="checkbox" name="alert.type" value="''')
            _v = VFFSL(SL,"path",True) # '$path' on line 540, col 97
            if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 540, col 97.
            write('''" ''')
            _v = VFFSL(SL,"checked",True) # '$checked' on line 540, col 104
            if _v is not None: write(_filter(_v, rawExpr='$checked')) # from line 540, col 104.
            write(''' /></td>
''')
        write('''       </tr>

       <tr>
        <th>''')
        if False:
            _("Severity:")
        _v = VFFSL(SL,"_",False)("Severity:") # '$_("Severity:")' on line 545, col 13
        if _v is not None: write(_filter(_v, rawExpr='$_("Severity:")')) # from line 545, col 13.
        write('''</th>
        ''')
        if False:
            N_("info")
        if False:
            N_("low")
        if False:
            N_("medium")
        if False:
            N_("high")
        if False:
            N_("none")
        for item in VFFSL(SL,"N_",False)("info"), VFFSL(SL,"N_",False)("low"), VFFSL(SL,"N_",False)("medium"), VFFSL(SL,"N_",False)("high"), VFFSL(SL,"N_",False)("none"): # generated from line 546, col 9
            write('''        <td>''')
            if False:
                _(VFFSL(SL,"item",True))
            _v = VFFSL(SL,"_",False)(VFFSL(SL,"item",True)) # '$_($item)' on line 547, col 13
            if _v is not None: write(_filter(_v, rawExpr='$_($item)')) # from line 547, col 13.
            write('''<input class="checkbox" type="checkbox" name="alert.assessment.impact.severity" value="''')
            _v = VFFSL(SL,"item",True) # '$item' on line 547, col 109
            if _v is not None: write(_filter(_v, rawExpr='$item')) # from line 547, col 109.
            write('''" /></td>
''')
        write('''       </tr>

       <tr>
        <th>''')
        if False:
            _("Completion:")
        _v = VFFSL(SL,"_",False)("Completion:") # '$_("Completion:")' on line 552, col 13
        if _v is not None: write(_filter(_v, rawExpr='$_("Completion:")')) # from line 552, col 13.
        write('''</th>
        <td colspan="2">&nbsp;</td>

        ''')
        if False:
            N_("succeeded")
        if False:
            N_("failed")
        if False:
            N_("none")
        for item in VFFSL(SL,"N_",False)("succeeded"), VFFSL(SL,"N_",False)("failed"), VFFSL(SL,"N_",False)("none"): # generated from line 555, col 9
            write('''        <td>''')
            if False:
                _(VFFSL(SL,"item",True))
            _v = VFFSL(SL,"_",False)(VFFSL(SL,"item",True)) # '$_($item)' on line 556, col 13
            if _v is not None: write(_filter(_v, rawExpr='$_($item)')) # from line 556, col 13.
            write('''<input class="checkbox" type="checkbox" name="alert.assessment.impact.completion" value="''')
            _v = VFFSL(SL,"item",True) # '$item' on line 556, col 111
            if _v is not None: write(_filter(_v, rawExpr='$item')) # from line 556, col 111.
            write('''" /></td>
''')
        write('''       </tr>
      </table>
     </td></tr>
     ''')
        _v = VFFSL(SL,"filter_reset",False)() # '$filter_reset()' on line 561, col 6
        if _v is not None: write(_filter(_v, rawExpr='$filter_reset()')) # from line 561, col 6.
        write('''
    </table>
    </div>
  </th>

  <th class="filter_popup">
   <a class="filter_popup_link">''')
        if False:
            _("Source")
        _v = VFFSL(SL,"_",False)("Source") # '$_("Source")' on line 567, col 33
        if _v is not None: write(_filter(_v, rawExpr='$_("Source")')) # from line 567, col 33.
        write('''</a>
''')
        if VFFSL(SL,"source_filtered",True): # generated from line 568, col 4
            write('''     ''')
            _v = VFFSL(SL,"filter_enabled_marker",False)(VFFSL(SL,"source_filtered",True)) # '$filter_enabled_marker($source_filtered)' on line 569, col 6
            if _v is not None: write(_filter(_v, rawExpr='$filter_enabled_marker($source_filtered)')) # from line 569, col 6.
            write('''
''')
        write('''   <div id="source">
    <table>
     <tr><td>''')
        _v = VFFSL(SL,"define_inline_filter",False)("source", "alert.source.node.address.address") # '$define_inline_filter("source", "alert.source.node.address.address")' on line 573, col 14
        if _v is not None: write(_filter(_v, rawExpr='$define_inline_filter("source", "alert.source.node.address.address")')) # from line 573, col 14.
        write('''</td></tr>
     <tr><td>''')
        _v = VFFSL(SL,"define_inline_aggreg",False)("source") # '$define_inline_aggreg("source")' on line 574, col 14
        if _v is not None: write(_filter(_v, rawExpr='$define_inline_aggreg("source")')) # from line 574, col 14.
        write('''</td></tr>
     ''')
        _v = VFFSL(SL,"filter_reset",False)() # '$filter_reset()' on line 575, col 6
        if _v is not None: write(_filter(_v, rawExpr='$filter_reset()')) # from line 575, col 6.
        write('''
    </table>
   </div>
  </th>

  <th class="filter_popup">
   <a class="filter_popup_link">''')
        if False:
            _("Target")
        _v = VFFSL(SL,"_",False)("Target") # '$_("Target")' on line 581, col 33
        if _v is not None: write(_filter(_v, rawExpr='$_("Target")')) # from line 581, col 33.
        write('''</a>
''')
        if VFFSL(SL,"target_filtered",True): # generated from line 582, col 4
            write('''     ''')
            _v = VFFSL(SL,"filter_enabled_marker",False)(VFFSL(SL,"target_filtered",True)) # '$filter_enabled_marker($target_filtered)' on line 583, col 6
            if _v is not None: write(_filter(_v, rawExpr='$filter_enabled_marker($target_filtered)')) # from line 583, col 6.
            write('''
''')
        write('''   <div id="target">
    <table>
     <tr><td>''')
        _v = VFFSL(SL,"define_inline_filter",False)("target", "alert.target.node.address.address") # '$define_inline_filter("target", "alert.target.node.address.address")' on line 587, col 14
        if _v is not None: write(_filter(_v, rawExpr='$define_inline_filter("target", "alert.target.node.address.address")')) # from line 587, col 14.
        write('''</td></tr>
     <tr><td>''')
        _v = VFFSL(SL,"define_inline_aggreg",False)("target") # '$define_inline_aggreg("target")' on line 588, col 14
        if _v is not None: write(_filter(_v, rawExpr='$define_inline_aggreg("target")')) # from line 588, col 14.
        write('''</td></tr>
     ''')
        _v = VFFSL(SL,"filter_reset",False)() # '$filter_reset()' on line 589, col 6
        if _v is not None: write(_filter(_v, rawExpr='$filter_reset()')) # from line 589, col 6.
        write('''
    </table>
   </div>
  </th>

  <th class="filter_popup">
   <a class="filter_popup_link">''')
        if False:
            _("Analyzer")
        _v = VFFSL(SL,"_",False)("Analyzer") # '$_("Analyzer")' on line 595, col 33
        if _v is not None: write(_filter(_v, rawExpr='$_("Analyzer")')) # from line 595, col 33.
        write('''</a>
''')
        if VFFSL(SL,"analyzer_filtered",True): # generated from line 596, col 4
            write('''     ''')
            _v = VFFSL(SL,"filter_enabled_marker",False)(VFFSL(SL,"analyzer_filtered",True)) # '$filter_enabled_marker($analyzer_filtered)' on line 597, col 6
            if _v is not None: write(_filter(_v, rawExpr='$filter_enabled_marker($analyzer_filtered)')) # from line 597, col 6.
            write('''
''')
        write('''   <div id="analyzer">
    <table>
     <tr><td>''')
        _v = VFFSL(SL,"define_inline_filter",False)("analyzer", "alert.analyzer.name") # '$define_inline_filter("analyzer", "alert.analyzer.name")' on line 601, col 14
        if _v is not None: write(_filter(_v, rawExpr='$define_inline_filter("analyzer", "alert.analyzer.name")')) # from line 601, col 14.
        write('''</td></tr>
     <tr><td>''')
        _v = VFFSL(SL,"define_inline_aggreg",False)("analyzer") # '$define_inline_aggreg("analyzer")' on line 602, col 14
        if _v is not None: write(_filter(_v, rawExpr='$define_inline_aggreg("analyzer")')) # from line 602, col 14.
        write('''</td></tr>
     ''')
        _v = VFFSL(SL,"filter_reset",False)() # '$filter_reset()' on line 603, col 6
        if _v is not None: write(_filter(_v, rawExpr='$filter_reset()')) # from line 603, col 6.
        write('''
    </table>
   </div>
  </th>

  <td>''')
        if False:
            _("Time")
        _v = VFFSL(SL,"_",False)("Time") # '$_("Time")' on line 608, col 7
        if _v is not None: write(_filter(_v, rawExpr='$_("Time")')) # from line 608, col 7.
        write('''</td>
</tr>
</thead>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeInlineFilter(self, inline_filter, optval=None, cl="", **KWS):



        ## CHEETAH: generated from #def writeInlineFilter(inline_filter, optval=None, cl="") at line 614, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        if optval: # generated from line 615, col 1
            if VFFSL(SL,"inline_filter.already_filtered",True): # generated from line 616, col 1
                write('''<span class="''')
                _v = VFFSL(SL,"cl",True) # '$cl' on line 617, col 14
                if _v is not None: write(_filter(_v, rawExpr='$cl')) # from line 617, col 14.
                write('''">''')
                _v = VFFSL(SL,"optval",True) # '$optval' on line 617, col 19
                if _v is not None: write(_filter(_v, rawExpr='$optval')) # from line 617, col 19.
                write('''</span>''')
            else: # generated from line 618, col 1
                write('''<a class="''')
                _v = VFFSL(SL,"cl",True) # '$cl' on line 619, col 11
                if _v is not None: write(_filter(_v, rawExpr='$cl')) # from line 619, col 11.
                write('''" href="''')
                _v = VFFSL(SL,"inline_filter.inline_filter",True) # '$inline_filter.inline_filter' on line 619, col 22
                if _v is not None: write(_filter(_v, rawExpr='$inline_filter.inline_filter')) # from line 619, col 22.
                write('''">''')
                _v = VFFSL(SL,"optval",True) # '$optval' on line 619, col 52
                if _v is not None: write(_filter(_v, rawExpr='$optval')) # from line 619, col 52.
                write('''</a>''')
        else: # generated from line 621, col 1
            if VFFSL(SL,"inline_filter.already_filtered",True): # generated from line 622, col 1
                write('''<span class="''')
                _v = VFFSL(SL,"cl",True) # '$cl' on line 623, col 14
                if _v is not None: write(_filter(_v, rawExpr='$cl')) # from line 623, col 14.
                write('''">''')
                _v = VFFSL(SL,"inline_filter.value",True) # '$inline_filter.value' on line 623, col 19
                if _v is not None: write(_filter(_v, rawExpr='$inline_filter.value')) # from line 623, col 19.
                write('''</span>''')
            else: # generated from line 624, col 1
                write('''<a class="''')
                _v = VFFSL(SL,"cl",True) # '$cl' on line 625, col 11
                if _v is not None: write(_filter(_v, rawExpr='$cl')) # from line 625, col 11.
                write('''" href="''')
                _v = VFFSL(SL,"inline_filter.inline_filter",True) # '$inline_filter.inline_filter' on line 625, col 22
                if _v is not None: write(_filter(_v, rawExpr='$inline_filter.inline_filter')) # from line 625, col 22.
                write('''">''')
                _v = VFFSL(SL,"inline_filter.value",True) # '$inline_filter.value' on line 625, col 52
                if _v is not None: write(_filter(_v, rawExpr='$inline_filter.value')) # from line 625, col 52.
                write('''</a>''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def classificationWrite(self, info, text, **KWS):



        ## CHEETAH: generated from #def classificationWrite(info, text) at line 630, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<a class="impact_severity_''')
        _v = VFFSL(SL,"info.severity.value",True) # '$info.severity.value' on line 631, col 27
        if _v is not None: write(_filter(_v, rawExpr='$info.severity.value')) # from line 631, col 27.
        write(''' popup_menu_toggle">''')
        _v = VFFSL(SL,"text",True) # '$text' on line 631, col 67
        if _v is not None: write(_filter(_v, rawExpr='$text')) # from line 631, col 67.
        write('''</a><span class="popup_menu">
- <a href="''')
        _v = VFFSL(SL,"info.display",True) # '$info.display' on line 632, col 12
        if _v is not None: write(_filter(_v, rawExpr='$info.display')) # from line 632, col 12.
        write('''">''')
        if False:
            _("See alert detail")
        _v = VFFSL(SL,"_",False)("See alert detail") # '$_("See alert detail")' on line 632, col 27
        if _v is not None: write(_filter(_v, rawExpr='$_("See alert detail")')) # from line 632, col 27.
        write('''</a><br />
- <a href="''')
        _v = VFFSL(SL,"info.classification.inline_filter",True) # '$info.classification.inline_filter' on line 633, col 12
        if _v is not None: write(_filter(_v, rawExpr='$info.classification.inline_filter')) # from line 633, col 12.
        write('''">''')
        if False:
            _("Filter on this classification.text")
        _v = VFFSL(SL,"_",False)("Filter on this classification.text") # '$_("Filter on this classification.text")' on line 633, col 48
        if _v is not None: write(_filter(_v, rawExpr='$_("Filter on this classification.text")')) # from line 633, col 48.
        write('''</a><br />
</span>''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeService(self, hstr, direction, **KWS):



        ## CHEETAH: generated from #def writeService($hstr, $direction) at line 637, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        if VFFSL(SL,"direction.service.value",True) != None: # generated from line 638, col 1
            _v = VFFSL(SL,"hstr",True) # '$hstr' on line 638, col 38
            if _v is not None: write(_filter(_v, rawExpr='$hstr')) # from line 638, col 38.
            write('''<a class="popup_menu_toggle">''')
            _v = VFFSL(SL,"str",False)(VFFSL(SL,"direction.service.value",True)) # '$str($direction.service.value)' on line 638, col 72
            if _v is not None: write(_filter(_v, rawExpr='$str($direction.service.value)')) # from line 638, col 72.
        write('''
</a>
       <span class="popup_menu">
        ''')
        _orig_filter_69090775 = _filter
        filterName = 'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''- ''')
        if False:
            _("Filter on this port/protocol")
        _v = VFFSL(SL,"writeInlineFilter",False)(VFFSL(SL,"direction.service",True), VFFSL(SL,"_",False)("Filter on this port/protocol")) # '$writeInlineFilter($direction.service, $_("Filter on this port/protocol"))' on line 641, col 26
        if _v is not None: write(_filter(_v, rawExpr='$writeInlineFilter($direction.service, $_("Filter on this port/protocol"))')) # from line 641, col 26.
        write('''<br/> ''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_69090775
        write('''
''')
        if VFFSL(SL,"direction.port.value",True): # generated from line 642, col 9
            write('''        - <a target="''')
            _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 643, col 22
            if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 643, col 22.
            write('''" href="https://www.prelude-ids.com/port_details.php?port=''')
            _v = VFFSL(SL,"str",False)(VFFSL(SL,"direction.port.value",True)) # '$str($direction.port.value)' on line 643, col 110
            if _v is not None: write(_filter(_v, rawExpr='$str($direction.port.value)')) # from line 643, col 110.
            write('''&amp;protocol=''')
            _v = VFN(VFFSL(SL,"direction.protocol.value",True),"upper",False)() # '$direction.protocol.value.upper()' on line 643, col 151
            if _v is not None: write(_filter(_v, rawExpr='$direction.protocol.value.upper()')) # from line 643, col 151.
            write('''">''')
            if False:
                _("Port/protocol information")
            _v = VFFSL(SL,"_",False)("Port/protocol information") # '$_("Port/protocol information")' on line 643, col 186
            if _v is not None: write(_filter(_v, rawExpr='$_("Port/protocol information")')) # from line 643, col 186.
            write('''</a>
''')
        else: # generated from line 644, col 9
            write('''        - <span>''')
            if False:
                _("Port/protocol information")
            _v = VFFSL(SL,"_",False)("Port/protocol information") # '$_("Port/protocol information")' on line 645, col 17
            if _v is not None: write(_filter(_v, rawExpr='$_("Port/protocol information")')) # from line 645, col 17.
            write('''</span>
''')
        write('''       </span>''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def message_fields(self, **KWS):



        ## CHEETAH: generated from #block message_fields at line 651, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_20418283 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''
<td>
''')
        if VFFSL(SL,"message.sub_alert_name",True): # generated from line 655, col 3
            write('''    <b>''')
            _v = VFFSL(SL,"message.sub_alert_type",True) # '$message.sub_alert_type' on line 656, col 8
            if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_type')) # from line 656, col 8.
            if VFFSL(SL,"message.sub_alert_display",True): # generated from line 657, col 5
                write('''      ''')
                if False:
                    ngettext("alert", "alerts", VFFSL(SL,"message.sub_alert_number",True))
                string = VFFSL(SL,"ngettext",False)("alert", "alerts", VFFSL(SL,"message.sub_alert_number",True))
                write('''      (<a href="''')
                _v = VFFSL(SL,"message.sub_alert_display",True) # '$message.sub_alert_display' on line 659, col 17
                if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_display')) # from line 659, col 17.
                write('''">''')
                _v = VFFSL(SL,"message.sub_alert_number",True) # '$message.sub_alert_number' on line 659, col 45
                if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_number')) # from line 659, col 45.
                write('''</a> ''')
                _v = VFFSL(SL,"string",True) # '$string' on line 659, col 75
                if _v is not None: write(_filter(_v, rawExpr='$string')) # from line 659, col 75.
                write(''')''')
            write(''':</b> <i><a href="''')
            _v = VFFSL(SL,"message.sub_alert_link",True) # '$message.sub_alert_link' on line 661, col 19
            if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_link')) # from line 661, col 19.
            write('''">''')
            _v = VFFSL(SL,"message.sub_alert_name",True) # '$message.sub_alert_name' on line 661, col 44
            if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_name')) # from line 661, col 44.
            write('''</a></i><br/>''')
        write('''
''')
        if VFFSL(SL,"message.aggregated",True) and VFFSL(SL,"message.aggregated_classifications_hidden",True) > 0: # generated from line 664, col 3
            write('''    ''')
            if False:
                _("%(hidden)d of %(total)d alerts not shown...")
            string = VFFSL(SL,"_",False)("%(hidden)d of %(total)d alerts not shown...")
            write('''    <b>(''')
            _v = VFFSL(SL,"str",False)(VFFSL(SL,"string",True) % { "hidden": VFFSL(SL,"message.aggregated_classifications_hidden",True), "total": VFFSL(SL,"message.aggregated_classifications_total",True) }) # '$str($string % { "hidden": $message.aggregated_classifications_hidden, "total": $message.aggregated_classifications_total })' on line 666, col 9
            if _v is not None: write(_filter(_v, rawExpr='$str($string % { "hidden": $message.aggregated_classifications_hidden, "total": $message.aggregated_classifications_total })')) # from line 666, col 9.
            write('''
    <a href="''')
            _v = VFFSL(SL,"message.aggregated_classifications_hidden_expand",True) # '$message.aggregated_classifications_hidden_expand' on line 667, col 14
            if _v is not None: write(_filter(_v, rawExpr='$message.aggregated_classifications_hidden_expand')) # from line 667, col 14.
            write('''">''')
            if False:
                _("expand")
            _v = VFFSL(SL,"_",False)("expand") # '$_("expand")' on line 667, col 65
            if _v is not None: write(_filter(_v, rawExpr='$_("expand")')) # from line 667, col 65.
            write('''</a>)</b>
    <br/>
''')
        write('''
''')
        for info in VFFSL(SL,"message.infos",True): # generated from line 671, col 3
            if VFFSL(SL,"info.classification.value",True): # generated from line 672, col 5
                text = VFFSL(SL,"info.classification.value",True)
            else: # generated from line 674, col 5
                text = "n/a"
            write('''
''')
            if VFFSL(SL,"message.aggregated",True) and (len(VFFSL(SL,"message.infos",True)) > 1 or VFFSL(SL,"info.count",True) > 1): # generated from line 678, col 5
                if VFFSL(SL,"info.count",True) == 1: # generated from line 679, col 7
                    write('''       ''')
                    _v = VFFSL(SL,"info.count",True) # '$info.count' on line 680, col 8
                    if _v is not None: write(_filter(_v, rawExpr='$info.count')) # from line 680, col 8.
                    write(''' x
        ''')
                    _orig_filter_60446335 = _filter
                    filterName = 'Filter'
                    if self._CHEETAH__filters.has_key("Filter"):
                        _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
                    else:
                        _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
                    _v = VFFSL(SL,"classificationWrite",False)(VFFSL(SL,"info",True), VFFSL(SL,"text",True)) # '$classificationWrite($info, $text)' on line 681, col 24
                    if _v is not None: write(_filter(_v, rawExpr='$classificationWrite($info, $text)')) # from line 681, col 24.
                    write(''' ''')
                    _filter = self._CHEETAH__currentFilter = _orig_filter_60446335
                    write('''
''')
                else: # generated from line 682, col 7
                    write('''      <a href="''')
                    _v = VFFSL(SL,"info.display",True) # '$info.display' on line 683, col 16
                    if _v is not None: write(_filter(_v, rawExpr='$info.display')) # from line 683, col 16.
                    write('''">''')
                    _v = VFFSL(SL,"info.count",True) # '$info.count' on line 683, col 31
                    if _v is not None: write(_filter(_v, rawExpr='$info.count')) # from line 683, col 31.
                    write('''</a> x
''')
                    if VFFSL(SL,"info.classification.already_filtered",True): # generated from line 684, col 8
                        write('''        <span class="impact_severity_''')
                        _v = VFFSL(SL,"info.severity.value",True) # '$info.severity.value' on line 685, col 38
                        if _v is not None: write(_filter(_v, rawExpr='$info.severity.value')) # from line 685, col 38.
                        write('''">''')
                        _v = VFFSL(SL,"text",True) # '$text' on line 685, col 60
                        if _v is not None: write(_filter(_v, rawExpr='$text')) # from line 685, col 60.
                        write('''</span>
''')
                    else: # generated from line 686, col 8
                        write('''        <a class="impact_severity_''')
                        _v = VFFSL(SL,"info.severity.value",True) # '$info.severity.value' on line 687, col 35
                        if _v is not None: write(_filter(_v, rawExpr='$info.severity.value')) # from line 687, col 35.
                        write('''" href="''')
                        _v = VFFSL(SL,"info.classification.inline_filter",True) # '$info.classification.inline_filter' on line 687, col 63
                        if _v is not None: write(_filter(_v, rawExpr='$info.classification.inline_filter')) # from line 687, col 63.
                        write('''">''')
                        _v = VFFSL(SL,"text",True) # '$text' on line 687, col 99
                        if _v is not None: write(_filter(_v, rawExpr='$text')) # from line 687, col 99.
                        write('''</a>
''')
            else: # generated from line 690, col 5
                if VFFSL(SL,"info.classification.already_filtered",True): # generated from line 691, col 7
                    write('''      <a class="impact_severity_''')
                    _v = VFFSL(SL,"info.severity.value",True) # '$info.severity.value' on line 692, col 33
                    if _v is not None: write(_filter(_v, rawExpr='$info.severity.value')) # from line 692, col 33.
                    write('''" href="''')
                    _v = VFFSL(SL,"info.display",True) # '$info.display' on line 692, col 61
                    if _v is not None: write(_filter(_v, rawExpr='$info.display')) # from line 692, col 61.
                    write('''">''')
                    _v = VFFSL(SL,"text",True) # '$text' on line 692, col 76
                    if _v is not None: write(_filter(_v, rawExpr='$text')) # from line 692, col 76.
                    write('''</a>
''')
                else: # generated from line 693, col 7
                    write('''       ''')
                    _orig_filter_54639722 = _filter
                    filterName = 'Filter'
                    if self._CHEETAH__filters.has_key("Filter"):
                        _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
                    else:
                        _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
                    _v = VFFSL(SL,"classificationWrite",False)(VFFSL(SL,"info",True), VFFSL(SL,"text",True)) # '$classificationWrite($info, $text)' on line 694, col 23
                    if _v is not None: write(_filter(_v, rawExpr='$classificationWrite($info, $text)')) # from line 694, col 23.
                    write(''' ''')
                    _filter = self._CHEETAH__currentFilter = _orig_filter_54639722
                    write('''
''')
            write('''
''')
            if VFFSL(SL,"info.completion.value",True): # generated from line 698, col 5
                write('''      (''')
                _orig_filter_72753057 = _filter
                filterName = 'Filter'
                if self._CHEETAH__filters.has_key("Filter"):
                    _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
                else:
                    _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
                _v = VFFSL(SL,"writeInlineFilter",False)(VFFSL(SL,"info.completion",True), cl="impact_completion_" + VFFSL(SL,"info.completion.value",True)) # '$writeInlineFilter($info.completion, cl="impact_completion_" + $info.completion.value)' on line 699, col 22
                if _v is not None: write(_filter(_v, rawExpr='$writeInlineFilter($info.completion, cl="impact_completion_" + $info.completion.value)')) # from line 699, col 22.
                _filter = self._CHEETAH__currentFilter = _orig_filter_72753057
                write(''')
''')
            write('''
    <br/>
''')
            sep = "("
            write('''
''')
            for url, name in VFFSL(SL,"info.classification_references",True): # generated from line 705, col 1
                _v = VFFSL(SL,"sep",True) # '$sep' on line 706, col 1
                if _v is not None: write(_filter(_v, rawExpr='$sep')) # from line 706, col 1.
                if VFFSL(SL,"url",True): # generated from line 706, col 5
                    write('''<a class="popup_menu_toggle">''')
                    _v = VFFSL(SL,"name.value",True) # '$name.value' on line 706, col 43
                    if _v is not None: write(_filter(_v, rawExpr='$name.value')) # from line 706, col 43.
                    write('''</a>''')
                else: # generated from line 706, col 58
                    _orig_filter_66829787 = _filter
                    filterName = 'Filter'
                    if self._CHEETAH__filters.has_key("Filter"):
                        _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
                    else:
                        _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
                    _v = VFFSL(SL,"writeInlineFilter",False)(VFFSL(SL,"name",True)) # '$writeInlineFilter($name)' on line 706, col 79
                    if _v is not None: write(_filter(_v, rawExpr='$writeInlineFilter($name)')) # from line 706, col 79.
                    _filter = self._CHEETAH__currentFilter = _orig_filter_66829787
                sep = ", "
                write('''<span class="popup_menu">
 - ''')
                _orig_filter_48737409 = _filter
                filterName = 'Filter'
                if self._CHEETAH__filters.has_key("Filter"):
                    _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
                else:
                    _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
                if False:
                    _("Filter on this reference")
                _v = VFFSL(SL,"writeInlineFilter",False)(VFFSL(SL,"name",True), VFFSL(SL,"_",False)("Filter on this reference")) # '$writeInlineFilter($name, $_("Filter on this reference"))' on line 709, col 19
                if _v is not None: write(_filter(_v, rawExpr='$writeInlineFilter($name, $_("Filter on this reference"))')) # from line 709, col 19.
                _filter = self._CHEETAH__currentFilter = _orig_filter_48737409
                write('''<br />
 - <a target="''')
                _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 710, col 15
                if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 710, col 15.
                write('''" href="''')
                _v = VFFSL(SL,"url",True) # '$url' on line 710, col 53
                if _v is not None: write(_filter(_v, rawExpr='$url')) # from line 710, col 53.
                write('''">Reference information</a>
</span>''')
            if VFFSL(SL,"info.classification_references",True): # generated from line 711, col 17
                write(''')''')
            write('''

''')
        write('''

</td>

''')
        if False:
            _("source")
        if False:
            _("target")
        for name, direction, hidden, total, expand in (VFFSL(SL,"_",False)("source"), VFFSL(SL,"message.source",True), VFFSL(SL,"message.aggregated_source_hidden",True), VFFSL(SL,"message.aggregated_source_total",True), VFFSL(SL,"message.aggregated_source_expand",True)), (VFFSL(SL,"_",False)("target"), VFFSL(SL,"message.target",True), VFFSL(SL,"message.aggregated_target_hidden",True), VFFSL(SL,"message.aggregated_target_total",True), VFFSL(SL,"message.aggregated_target_expand",True)): # generated from line 718, col 1
            write('''<td>
''')
            if len(VFFSL(SL,"direction",True)) == 0: # generated from line 720, col 1
                write('''       n/a
''')
            write('''
''')
            need_hr = 0
            write('''
''')
            if VFFSL(SL,"hidden",True) > 0: # generated from line 726, col 1
                write('''       ''')
                if False:
                    _("%(hidden)d of %(total)d %(name)ss not shown...")
                string = VFFSL(SL,"_",False)("%(hidden)d of %(total)d %(name)ss not shown...")
                write('''       <b>(''')
                _v = VFFSL(SL,"str",False)(VFFSL(SL,"string",True) % { "hidden": VFFSL(SL,"hidden",True), "total": VFFSL(SL,"total",True), "name": VFFSL(SL,"name",True) }) # '$str($string % { "hidden": $hidden, "total": $total, "name": $name })' on line 728, col 12
                if _v is not None: write(_filter(_v, rawExpr='$str($string % { "hidden": $hidden, "total": $total, "name": $name })')) # from line 728, col 12.
                write('''
       <a href="''')
                _v = VFFSL(SL,"expand",True) # '$expand' on line 729, col 17
                if _v is not None: write(_filter(_v, rawExpr='$expand')) # from line 729, col 17.
                write('''">''')
                if False:
                    _("expand")
                _v = VFFSL(SL,"_",False)("expand") # '$_("expand")' on line 729, col 26
                if _v is not None: write(_filter(_v, rawExpr='$_("expand")')) # from line 729, col 26.
                write('''</a>)</b>
       <br/>
''')
            write('''
''')
            for direction in VFFSL(SL,"direction",True): # generated from line 733, col 1
                if VFFSL(SL,"need_hr",True): # generated from line 734, col 7
                    write('''        <hr style="border: 1px dashed #808080; margin-top: 3px; margin-bottom: 0px;" />
''')
                write('''
''')
                need_hr = 1
                write('''
''')
                for address in VFFSL(SL,"direction.addresses",True): # generated from line 740, col 7
                    write('''       <a class="popup_menu_toggle">''')
                    _v = VFFSL(SL,"address.hostname",True) # '$address.hostname' on line 741, col 37
                    if _v is not None: write(_filter(_v, rawExpr='$address.hostname')) # from line 741, col 37.
                    write('''</a><span class="popup_menu">
         - ''')
                    _orig_filter_92159488 = _filter
                    filterName = 'Filter'
                    if self._CHEETAH__filters.has_key("Filter"):
                        _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
                    else:
                        _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
                    if False:
                        _("Filter on this %s")
                    _v = VFFSL(SL,"writeInlineFilter",False)(VFFSL(SL,"address",True), VFFSL(SL,"str",False)(VFFSL(SL,"_",False)("Filter on this %s") % (VFFSL(SL,"name",True)))) # '$writeInlineFilter($address, $str($_("Filter on this %s") % ($name)))' on line 742, col 27
                    if _v is not None: write(_filter(_v, rawExpr='$writeInlineFilter($address, $str($_("Filter on this %s") % ($name)))')) # from line 742, col 27.
                    write(''' ''')
                    _filter = self._CHEETAH__currentFilter = _orig_filter_92159488
                    write('''
         <br />

''')
                    if not VFFSL(SL,"address.category",True) or VFFSL(SL,"address.category",True) in ("ipv4-addr", "ipv4-net", "ipv6-addr", "ipv6-net"): # generated from line 745, col 8
                        write('''         - <a target="''')
                        _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 746, col 23
                        if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 746, col 23.
                        write('''" href="https://www.prelude-ids.com/host_details.php?host=''')
                        _v = VFFSL(SL,"address.value",True) # '$address.value' on line 746, col 111
                        if _v is not None: write(_filter(_v, rawExpr='$address.value')) # from line 746, col 111.
                        write('''">''')
                        if False:
                            _("%s information")
                        _v = VFN(VFFSL(SL,"str",False)(VFFSL(SL,"_",False)("%s information") % (VFFSL(SL,"name",True))),"capitalize",False)() # '$str($_("%s information") % ($name)).capitalize()' on line 746, col 127
                        if _v is not None: write(_filter(_v, rawExpr='$str($_("%s information") % ($name)).capitalize()')) # from line 746, col 127.
                        write('''</a><br />

''')
                        for cmdname, link in VFFSL(SL,"address.host_commands",True): # generated from line 748, col 11
                            write('''         - <a href="''')
                            _v = VFFSL(SL,"link",True) # '$link' on line 749, col 21
                            if _v is not None: write(_filter(_v, rawExpr='$link')) # from line 749, col 21.
                            write('''">''')
                            _v = VFFSL(SL,"cmdname",True) # '$cmdname' on line 749, col 28
                            if _v is not None: write(_filter(_v, rawExpr='$cmdname')) # from line 749, col 28.
                            write('''</a><br />
''')
                    write('''       </span>''')
                    _orig_filter_38452123 = _filter
                    filterName = 'Filter'
                    if self._CHEETAH__filters.has_key("Filter"):
                        _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
                    else:
                        _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
                    _v = VFFSL(SL,"writeService",False)(":", VFFSL(SL,"direction",True)) # '$writeService(":", $direction)' on line 753, col 16
                    if _v is not None: write(_filter(_v, rawExpr='$writeService(":", $direction)')) # from line 753, col 16.
                    write(''' ''')
                    _filter = self._CHEETAH__currentFilter = _orig_filter_38452123
                    write('''
<br />
''')
                write('''
''')
                if VFFSL(SL,"len",False)(VFFSL(SL,"direction.addresses",True)) == 0: # generated from line 757, col 7
                    write('''        ''')
                    _orig_filter_26996848 = _filter
                    filterName = 'Filter'
                    if self._CHEETAH__filters.has_key("Filter"):
                        _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
                    else:
                        _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
                    _v = VFFSL(SL,"writeService",False)("service:", VFFSL(SL,"direction",True)) # '$writeService("service:", $direction)' on line 758, col 24
                    if _v is not None: write(_filter(_v, rawExpr='$writeService("service:", $direction)')) # from line 758, col 24.
                    write(''' ''')
                    _filter = self._CHEETAH__currentFilter = _orig_filter_26996848
                    write('''
''')
                write('''
''')
                cnt = 0
                for name, value, extra in VFFSL(SL,"direction.listed_values",True): # generated from line 762, col 6
                    if VFFSL(SL,"cnt",True) > 0: # generated from line 763, col 10
                        write('''          <br />
''')
                    write('''
         ''')
                    _v = VFFSL(SL,"name",True) # '$name' on line 767, col 10
                    if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 767, col 10.
                    write(''': ''')
                    _orig_filter_93049525 = _filter
                    filterName = 'Filter'
                    if self._CHEETAH__filters.has_key("Filter"):
                        _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
                    else:
                        _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
                    _v = VFFSL(SL,"writeInlineFilter",False)(VFFSL(SL,"value",True)) # '$writeInlineFilter($value)' on line 767, col 32
                    if _v is not None: write(_filter(_v, rawExpr='$writeInlineFilter($value)')) # from line 767, col 32.
                    write(''' ''')
                    _filter = self._CHEETAH__currentFilter = _orig_filter_93049525
                    write('''
''')
                    if VFFSL(SL,"extra",True) != None: # generated from line 768, col 10
                        write('''          (''')
                        _v = VFFSL(SL,"extra",True) # '$extra' on line 769, col 12
                        if _v is not None: write(_filter(_v, rawExpr='$extra')) # from line 769, col 12.
                        write(''')
''')
                    write('''
''')
                    cnt += 1
            write('''
</td>
''')
        write('''
<td>
''')
        for sensor in VFFSL(SL,"message.sensors",True): # generated from line 780, col 3
            if VFFSL(SL,"sensor.name.value",True): # generated from line 781, col 5
                write('''     ''')
                _orig_filter_58484317 = _filter
                filterName = 'Filter'
                if self._CHEETAH__filters.has_key("Filter"):
                    _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
                else:
                    _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
                _v = VFFSL(SL,"writeInlineFilter",False)(VFFSL(SL,"sensor.name",True)) # '$writeInlineFilter($sensor.name)' on line 782, col 20
                if _v is not None: write(_filter(_v, rawExpr='$writeInlineFilter($sensor.name)')) # from line 782, col 20.
                _filter = self._CHEETAH__currentFilter = _orig_filter_58484317
                write('''
''')
            if VFFSL(SL,"sensor.node_name.value",True): # generated from line 784, col 5
                write('''      (''')
                _orig_filter_57639190 = _filter
                filterName = 'Filter'
                if self._CHEETAH__filters.has_key("Filter"):
                    _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
                else:
                    _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
                _v = VFFSL(SL,"writeInlineFilter",False)(VFFSL(SL,"sensor.node_name",True)) # '$writeInlineFilter($sensor.node_name)' on line 785, col 22
                if _v is not None: write(_filter(_v, rawExpr='$writeInlineFilter($sensor.node_name)')) # from line 785, col 22.
                _filter = self._CHEETAH__currentFilter = _orig_filter_57639190
                write(''')
''')
            write('''    <br/>
''')
        write('''</td>
<td>
''')
        if VFFSL(SL,"message.aggregated",True): # generated from line 791, col 3
            if VFFSL(SL,"message.time_min.value",True) == VFFSL(SL,"message.time_max.value",True): # generated from line 792, col 5
                write('''      ''')
                _v = VFFSL(SL,"message.time_min.value",True) # '$message.time_min.value' on line 793, col 7
                if _v is not None: write(_filter(_v, rawExpr='$message.time_min.value')) # from line 793, col 7.
                write('''
''')
            else: # generated from line 794, col 5
                write('''      ''')
                _v = VFFSL(SL,"message.time_max.value",True) # '$message.time_max.value' on line 795, col 7
                if _v is not None: write(_filter(_v, rawExpr='$message.time_max.value')) # from line 795, col 7.
                write(''' -
      ''')
                _v = VFFSL(SL,"message.time_min.value",True) # '$message.time_min.value' on line 796, col 7
                if _v is not None: write(_filter(_v, rawExpr='$message.time_min.value')) # from line 796, col 7.
                write('''
''')
        else: # generated from line 798, col 3
            write('''    ''')
            _v = VFFSL(SL,"message.time.value",True) # '$message.time.value' on line 799, col 5
            if _v is not None: write(_filter(_v, rawExpr='$message.time.value')) # from line 799, col 5.
            write('''
''')
            if VFFSL(SL,"message.analyzer_time.value",True): # generated from line 800, col 5
                write('''      (sent at ''')
                _v = VFFSL(SL,"message.analyzer_time.value",True) # '$message.analyzer_time.value' on line 801, col 16
                if _v is not None: write(_filter(_v, rawExpr='$message.analyzer_time.value')) # from line 801, col 16.
                write(''')
''')
        write('''</td>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_20418283
        _orig_filter_82366066 = _filter
        filterName = 'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        _filter = self._CHEETAH__currentFilter = _orig_filter_82366066
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def orderby_option(self, **KWS):



        ## CHEETAH: generated from #block orderby_option at line 811, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''     <option value="time_desc" ''')
        _v = VFFSL(SL,"timeline.time_desc_selected",True) # '$timeline.time_desc_selected' on line 812, col 32
        if _v is not None: write(_filter(_v, rawExpr='$timeline.time_desc_selected')) # from line 812, col 32.
        write('''>By time (descending)</option>
     <option value="time_asc" ''')
        _v = VFFSL(SL,"timeline.time_asc_selected",True) # '$timeline.time_asc_selected' on line 813, col 31
        if _v is not None: write(_filter(_v, rawExpr='$timeline.time_asc_selected')) # from line 813, col 31.
        write('''>By time (ascending)</option>
     <option value="count_desc" ''')
        _v = VFFSL(SL,"timeline.count_desc_selected",True) # '$timeline.count_desc_selected' on line 814, col 33
        if _v is not None: write(_filter(_v, rawExpr='$timeline.count_desc_selected')) # from line 814, col 33.
        write('''>By count (descending)</option>
     <option value="count_asc" ''')
        _v = VFFSL(SL,"timeline.count_asc_selected",True) # '$timeline.count_asc_selected' on line 815, col 32
        if _v is not None: write(_filter(_v, rawExpr='$timeline.count_asc_selected')) # from line 815, col 32.
        write('''>By count (ascending)</option>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def timeline_extra_content(self, **KWS):



        ## CHEETAH: generated from #block timeline_extra_content at line 819, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_72580054 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''<tr>
  <th id="filter_control_label">''')
        if False:
            _("Filter")
        _v = VFFSL(SL,"_",False)("Filter") # '$_("Filter")' on line 822, col 33
        if _v is not None: write(_filter(_v, rawExpr='$_("Filter")')) # from line 822, col 33.
        write('''</th>
  <td colspan="2">
   <select name="filter" size="1" class="filter_control_select">
    <option value="">&nbsp;</option>
''')
        for fltr in VFFSL(SL,"filters",True): # generated from line 826, col 3
            write('''    <option value="''')
            _v = VFFSL(SL,"fltr",True) # '$fltr' on line 827, col 20
            if _v is not None: write(_filter(_v, rawExpr='$fltr')) # from line 827, col 20.
            write('''" ''')
            if VFFSL(SL,"fltr",True) == VFFSL(SL,"current_filter",True): # generated from line 827, col 27
                write(''' selected="selected" ''')
            write('''>''')
            _v = VFFSL(SL,"fltr",True) # '$fltr' on line 827, col 86
            if _v is not None: write(_filter(_v, rawExpr='$fltr')) # from line 827, col 86.
            write('''</option>
''')
        write('''  </select>
 </td>
</tr>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_72580054
        _orig_filter_97912449 = _filter
        filterName = 'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        _filter = self._CHEETAH__currentFilter = _orig_filter_97912449
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        self.head_extra_content(trans=trans)
        write('''





''')
        self.message_fields_header(trans=trans)
        write('''





''')
        self.message_fields(trans=trans)
        write('''

''')
        self.orderby_option(trans=trans)
        write('''

''')
        self.timeline_extra_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_AlertListing= 'writeBody'

## END CLASS DEFINITION

if not hasattr(AlertListing, '_initCheetahAttributes'):
    templateAPIClass = getattr(AlertListing, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(AlertListing)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=AlertListing()).run()


